#include <avr/io.h>

// Librairie AtMega pour ADC

#include "..\ladder.h"
#include "PwmLib.h"


#if defined (LDTARGET_atmega328) || defined (LDTARGET_atmega16)
void ADC_Init(int canal, int div, int resol)
	{
	if (resol == 8)	  // conversion 8 ou 10 bits
	   	ADMUX= (1 << REFS0) | (1 << ADLAR);
	else
		ADMUX= (1 << REFS0);

	// frquence d'chantillonage selon frquence XTAL
	ADCSRA |= (div & 0x07);		// division par 2^div
	ADCSRA= (1 << ADEN);		// demarrage ADC

	ADMUX &= 0xE0;		   		// RAZ canaux acquisition
	ADMUX |= (canal & 0x07);	// canal acquisition 0  7
	}

void ADC_Stop()
	{
    ADCSRA= 0;
	}

unsigned ADC_Read(int canal)
	{
    ADMUX &= 0xE0;		   		// RAZ canaux acquisition
	ADMUX |= (canal & 0x07);	// canal acquisition 0  7

	ADCSRA |= (1 << ADSC);		   		// acquisition analogique
	while(ADCSRA & (1 << ADSC));	   	// attente fin conversion

	if (ADMUX & (1 << ADLAR))
		return ADCH;  		// 8 bits seulement
	else
		return ADC;	   		// 10 bits ADC= ADCL + ADCH
	}
#endif

