/* This is auto-generated C code from LDmicro. Do not edit this file! Go
   back to the LDmicro ladder diagram source for changes in the ladder logic.

   Yous must provide additional librairies for I/O read/write operations
   and for used peripherals (Timer, ADC, PWM, UART, SPI...) in 'lib' subdirectory
   of the folder containing the ladder .ld file, so that it should be compiled
   and liked with this file when running flashMcu.bat.
   Generated .elf and .hex files will be created in 'bin' subdirectory.*/

#include "ladder.h"
#include "test-spi.h" // Copy this line into main project file where is function main().

/* Define EXTERN_EVERYTHING in ladder.h if you want all symbols extern.
   This could be useful to implement `magic variables,' so that for
   example when you write to the ladder variable duty_cycle, your PLC
   runtime can look at the C variable U_duty_cycle and use that to set
   the PWM duty cycle on the micro. That way you can add support for
   peripherals that LDmicro doesn't know about. */
#ifdef EXTERN_EVERYTHING
  #define STATIC
#else
  #define STATIC static
#endif

/* Ux_xxx symbols correspond to user-defined names. There is such a symbol
   for every internal relay, variable, timer, and so on in the ladder
   program. Ix_xxx symbols are internally generated. */
/* Ix_xxx
   Ux_xxx
    ^
    b means bool type
    i means int type */

STATIC ldBOOL Ib_rung_top = 0;
STATIC ldBOOL Ub_Ronce = 0;
STATIC SWORD Ui_Tnew = 0;
STATIC SWORD Ui_SPI = 0;
STATIC SWORD Ui_send = 0;
#ifndef USE_MACRO
  // LDmicro provide this function.
  ldBOOL Read_Ub_Xbutton(void) {
    return PIND & (1<<PIND7);
  }
#endif

STATIC ldBOOL Ib_once_0_ONE_SHOT_RISING_ = 0;
STATIC SWORD Ui_recv = 0;

SWORD SPI_SendRecv(SWORD send) {
  SWORD recv= 0;
  recv= SPI_Send(send);
  return recv;
}

void SPI_Write(char * string) {
  int i= 0;
  while(string[i] != 0) {
    SPI_Send(string[i]);
    i++;
   }
}


/* Call this function once per PLC cycle. You are responsible for calling
   it at the interval that you specified in the LDmicro MCU configuration when you
   generated this code. */
void PlcCycle(void) {
    
    // ======= START RUNG 1 =======
    LabelRung1:;
    Write_Ib_rung_top(1);
    // start series [
    // ELEM_CONTACTS
    if(Read_Ub_Ronce()) {
        Write_Ib_rung_top(0);
    }
    // ELEM_TON Tnew 3000000
    if(Read_Ib_rung_top()) {
        if(Ui_Tnew < 300) {
            Write_Ib_rung_top(0);
            Ui_Tnew++;
        }
    } else {
        Ui_Tnew = 0;
    }
    // ELEM_SPI_WR
    if(Read_Ib_rung_top()) {
        SPI_Write("Hello");
        Write_Ib_rung_top(1);
    }
    // ELEM_COIL
    if(Read_Ib_rung_top()) {
        Write_Ub_Ronce(1);
    }
    // ] finish series
    
    // ======= START RUNG 2 =======
    LabelRung2:;
    Write_Ib_rung_top(1);
    // start series [
    // ELEM_MOVE
    if(Read_Ib_rung_top()) {
        Ui_send = 65;
    }
    // ] finish series
    
    // ======= START RUNG 3 =======
    LabelRung3:;
    Write_Ib_rung_top(1);
    // start series [
    // ELEM_CONTACTS
    if(Read_Ub_Xbutton()) {
        Write_Ib_rung_top(0);
    }
    // ELEM_ONE_SHOT_RISING
    if(Read_Ib_rung_top()) {
        if(Read_Ib_once_0_ONE_SHOT_RISING_()) {
            Write_Ib_rung_top(0);
        } else {
            Write_Ib_once_0_ONE_SHOT_RISING_(1);
        }
    } else {
        Write_Ib_once_0_ONE_SHOT_RISING_(0);
    }
    // ELEM_SPI
    if(Read_Ib_rung_top()) {
        Ui_recv= SPI_SendRecv(Ui_send);
        Write_Ib_rung_top(1);
    }
    // ] finish series
    LabelRung4:;
}

void setupPlc(void) {
    // Set up I/O pins direction, and drive the outputs low to start.
    DDRB = 0x00;
    PORTB = 0x00;
    DDRC = 0x00;
    PORTC = 0x00;
    DDRD = 0x00;
    PORTD = 0x80;
    // Initialize PLC cycle timer here.
    // Configure Timer 0
    TCCR1A = 0x00; // WGM11=0, WGM10=0
    TCCR1B = (1<<WGM12) | 5; // WGM13=0, WGM12=1
    // `the high byte must be written before the low byte
    OCR1AH = (35 >> 8) & 0xff;
    OCR1AL = 35  & 0xff;

    SPI_Init(SPI_GetPrescaler(3686400, 28800));
}

void mainPlc(void) { // Call mainPlc() function in main() of your project.
    setupPlc();
    while(1) {
        // Test PLC cycle timer interval here.
        #ifndef TIFR
        #define TIFR TIFR1
        #endif
        while((TIFR & (1<<OCF1A)) == 0);
        TIFR |= 1<<OCF1A; // OCF1A can be cleared by writing a logic one to its bit location


        PlcCycle();
        // You can place your code here, if you don't generate C code from LDmicro again.
        // ...
    }
}

#ifdef __CODEVISIONAVR__
void main(void) { // You can use this as is.
    mainPlc();
    return;
}
#else
int main(void) { // You can use this as is.
    mainPlc();
    return 0;
}
#endif
